'use client'

import React, { useState } from 'react';

import { IoLanguage } from 'react-icons/io5';

import { LangOption } from '@/meta/settings';

import Icon from '../Icon';

import LangSwitcher from '../LangSwitcher';

interface Props {
    labels: {
        title: string
        langs: LangOption[]
    }
}

const Language: React.FC<Props> = (props) => {

    const { labels } = props

    const [showModal, setShowModal] = useState<boolean>(false)

    return (
        <>
            <Icon handleClick={() => setShowModal(true)}>
                {<IoLanguage size={24} />}
            </Icon>

            {showModal && <LangSwitcher handleClose={() => setShowModal(false)} labels={labels} />}

        </>
    );
};

export default Language;