import React from 'react';

import Header from '@/components/Layout/Header';
import SearchBar from '@/components/Layout/SearchBar';
import Results from '@/components/Layout/Results';
import { GalleryData } from '@/meta/data';

interface Props {
    query: string
    data: GalleryData[]
}

const Search: React.FC<Props> = (props) => {

    const { query, data } = props;

    return (
        <>
            <Header />
            <SearchBar query={query} />
            <Results data={data} />
        </>
    );
};

export default Search;