import React from 'react';

import Header from '@/components/Layout/Header';

import VideoJS from '@/components/Layout/VideoJS';
import PlyrJS from '@/components/Layout/PlyrJS';

import SearchBar from '@/components/Layout/SearchBar';
import Results from '@/components/Layout/Results';

import { GalleryData, VideoData } from '@/meta/data';
import { Platforms } from '@/meta/settings';
import Disclaimer from '@/components/Layout/Header/Disclaimer';
import { platform } from 'os';


interface Props {
    id: string
    data: VideoData
    related: GalleryData[]
    platform: Platforms
}

const Video: React.FC<Props> = (props) => {

    const { data, related, platform } = props;

    return (
        <>
            <Header />
            <Disclaimer platform={platform} />
            {data.srcSet ? <PlyrJS data={data} /> : <VideoJS data={data} />}
            <SearchBar />
            {related && <Results data={related} />}
        </>
    );
};

export default Video;