import { createClient } from 'redis';

export const getDataFromRedis = async (key: string): Promise<Object | null> => {

    if (Boolean(process.env.ENABLE_REDIS)) {

        const redis = await createClient({ url: process.env.REDIS_URL })
            .on('error', err => console.log('Redis Client Error', err))
            .connect()

        const cached = await redis.get(key);

        if (cached) {
            await redis.disconnect();

            return JSON.parse(cached)
        } else {
            return null
        }


    } else {
        return null
    }
}

export const storeDataIntoRedis = async (key: string, data: Object, expiry?: Object) => {
    if (Boolean(process.env.ENABLE_REDIS)) {
        const redis = await createClient({ url: process.env.REDIS_URL })
            .on('error', err => console.log('Redis Client Error', err))
            .connect()

        await redis.set(key, JSON.stringify(data), expiry);

        await redis.disconnect();
    }

} 