import { Themes } from "@/meta/settings";

import { createSlice } from "@reduxjs/toolkit";
import type { PayloadAction } from "@reduxjs/toolkit";


export interface ISettingsState {
  theme: Themes;
}

const initialState: ISettingsState = {
  theme: Themes.light,
};

export const settingsSlice = createSlice({
  name: "settings",
  initialState,
  reducers: {
    setCurrentTheme: (state, action: PayloadAction<Themes>) => {
      state.theme = action.payload;
    },
  },
});

export const { setCurrentTheme } = settingsSlice.actions;
export const settingsReducer = settingsSlice.reducer;