'use server'

import { Cookies as AppCookies, DEFAULT_PLATFORM, Platforms } from '@/meta/settings';
import { cookies } from 'next/headers'

export async function getCookie(name: AppCookies) {
  return cookies().get(name);    
}

export async function hasCookie(name: AppCookies):Promise<boolean> {
  return cookies().has(name)
}

export async function getPlatformCookie(): Promise<Platforms> {
  const platformCookie = await getCookie(AppCookies.platform)
  return platformCookie && platformCookie.value ? platformCookie.value as Platforms : DEFAULT_PLATFORM
}