import { PORNHUB_BASE_URL, PORNHUB_BASE_URL_VIDEO } from "@/constants/urls";
import { FetchParams, GalleryData, VideoData, VideoSourceItem } from "@/meta/data";
import { getHeaders } from "../common/headers";
import { getDataFromRedis, storeDataIntoRedis } from "@/redis/client";
import { DEFAULT_PORNHUB_GALLERY_EXPIRY, DEFAULT_PORNHUB_VIDEO_EXPIRY, DEFAULT_RELATED_VIDEO_KEY_PATH } from "@/constants/redis";

import * as cheerio from "cheerio";

import axios, { AxiosError } from "axios";
import { createSessionCookie, findGetMediaUrlInTagblock, findGetRelatedUrlInTagblock } from "../common/mindgeek";
import { getPornHubMediaUrlList, getPornHubRelatedVideoData } from "./url";

export const fetchPornHubVideoData = async (videoId: string, params?: FetchParams): Promise<[VideoData, GalleryData[]]> => {

    let data: VideoData = {
        lowResUrl: '',
        srcSet: []
    }

    let relatedData: GalleryData[] = [];

    let mediaUrl, relatedUrl, sessionCookie, convertedData: VideoSourceItem[]

    let reqHeaders = getHeaders(PORNHUB_BASE_URL)

    const queryUrl = `${PORNHUB_BASE_URL_VIDEO}${videoId.replace(/\//g, '')}`

    const cachedVideoData = await getDataFromRedis(queryUrl)
    const cachedRelatedData = await getDataFromRedis(queryUrl + DEFAULT_RELATED_VIDEO_KEY_PATH)

    if (cachedVideoData) {
        return [cachedVideoData as VideoData, cachedRelatedData as GalleryData[] ?? []]
    }

    await axios.get(queryUrl, reqHeaders)

        .then(async response => {

            sessionCookie = response?.headers["set-cookie"] ? createSessionCookie(response?.headers["set-cookie"]) : '';

            const html = response.data;

            const $ = cheerio.load(html);

            const scriptTags = $("script");

            scriptTags.map((idx, elem) => {
                const getMediaUrl = findGetMediaUrlInTagblock($(elem).toString()) ?? null

                if (getMediaUrl) {
                    mediaUrl = getMediaUrl
                }

            })

            scriptTags.map((idx, elem) => {
                const getRelatedUrl = findGetRelatedUrlInTagblock($(elem).toString()) ?? null

                if (getRelatedUrl) {
                    relatedUrl = getRelatedUrl
                }

            })

        }).catch((error: AxiosError) => {
            // error handling goes here
        });

    if (sessionCookie && mediaUrl) {
        convertedData = await getPornHubMediaUrlList(mediaUrl, sessionCookie)
        data.srcSet = convertedData.reverse()

        await storeDataIntoRedis(queryUrl, data, DEFAULT_PORNHUB_VIDEO_EXPIRY);
    }

    if (sessionCookie && relatedUrl) {
        if (cachedRelatedData) {
            relatedData = cachedRelatedData as GalleryData[]
        } else {
            relatedData = await getPornHubRelatedVideoData(relatedUrl, sessionCookie)
        
            await storeDataIntoRedis(queryUrl + DEFAULT_RELATED_VIDEO_KEY_PATH, relatedData, DEFAULT_PORNHUB_GALLERY_EXPIRY);
        }

    }

    return [ data, relatedData ]
}