import { XNXX_BASE_SEARCH, XNXX_BASE_URL_ETERO, XNXX_BASE_URL_GAY, XNXX_BASE_URL_TRANS } from '@/constants/urls';
import { Cookies, XVideosCatQueryMap, XVideosOrientations } from '@/meta/settings';
import { getCookie } from '@/utils/cookies/read';

export const getXNXXQueryUrl = async (query?: string) => {
    
    const category = await getCookie(Cookies.orientation)

    if (!category && !query) {
        return XNXX_BASE_URL_ETERO
    }

    if (!category && query) {
        return `${XNXX_BASE_SEARCH}/${query}`
    }

    if (category && !Object.values(XVideosOrientations).includes(category.value as XVideosOrientations)) {
        return XNXX_BASE_URL_ETERO 
    }

    if (category && !query) {
        switch (category.value) {
            case XVideosOrientations.etero:
                return XNXX_BASE_URL_ETERO
            case XVideosOrientations.gay:
                return XNXX_BASE_URL_GAY
            case XVideosOrientations.trans:
                return XNXX_BASE_URL_TRANS
            default:
                return XNXX_BASE_URL_ETERO;
        }
    }

    if (category && query) {
        return `${XNXX_BASE_SEARCH}/${XVideosCatQueryMap[category.value as XVideosOrientations]}/${query}`
    }

    return XNXX_BASE_URL_ETERO

}